#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
Script to read nmea data from a GPS mouse
Copyright (C) 2008  Andreas Goelzer
 
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
This program reads data from a nmea device (uses the GGA sentence),
and creates a google kml file with the current position and the path
leading there. Additionally, a gpx file is generated containing the
track data with time information.
"""

from serial import Serial;
from optparse import OptionParser;
from time import sleep;
from threading import Thread;
from sys import stdout;

parser = OptionParser(version="%prog 0.1");
parser.add_option("-s", "--serial", dest="serial",
                  help="serial terminal of the gps unit", default='/dev/ttyUSB0', metavar="FILE");
 
(options, args) = parser.parse_args();

servoc = Serial(options.serial, 9600, timeout=1);


class receiver(Thread):
	def __init__(self):
		Thread.__init__(self);
		self.endless = True;
	def run(self):
		while(self.endless):
			line = servoc.read();
			stdout.write(line)
			sleep(0.001)
		
receiverthread = receiver();
receiverthread.start();
print "Start"
servoc.write("v");
try:
	while 1:
		print "going there"
		for i in range(9,12):
			servoc.write("s %i 15000\n" % i);
			sleep(0.1);
		sleep(1);
		print "going back"
		for i in range(9,12):
			servoc.write("s %i 5000\n" % i);
			sleep(0.1);
		sleep(1);

except:
	receiverthread.endless = False;
servoc.close()
